<template>
    <div class="attendance">
        <q-page class="row background-content">
            <div class="col-12">
                <div class="row q-pa-md">
                    <div class="row items-center col-5 col-md-2 col-lg-2">
                        <div class="row justify-center title items-center text-center">
                            <p class="title-text helvetica-neue-medium">
                                {{ $t('attendance.title') }}
                            </p>
                        </div>
                    </div>

                    <!-- MOBILE VIEW -->
                    <div class="col-5 row justify-end items-center lt-md">
                        <auto-assign
                            class="row justify-end q-mt-sm items-center"
                        />
                    </div>
                    <div class="col-2 row justify-center items-center lt-md">
                        <notifications v-if="windowWidth <= 450"
                            class="row justify-end q-mt-sm items-center"
                        />
                    </div>

                    <div
                        class="
                            col-2
                            offset-7
                            row
                            justify-end
                            items-center
                            gt-sm
                        "
                    >
                        <auto-assign />
                    </div>
                    <div
                        class="
                            col-1
                            row
                            justify-center
                            items-center
                            q-pr-lg
                            gt-sm
                        "
                    >
                        <notifications v-if="windowWidth > 450" />
                    </div>
                </div>

                <div class="row q-px-md">
                    <div class="col-12">
                        <div class="page-content q-pt-lg q-pb-lg q-px-xl">
                            <div
                                class="row justify-center"
                                v-if="!state.attendanceMode"
                            >
                                <q-item class="items-center">
                                    <q-img
                                        v-if="selectedBusiness.imageUrl"
                                        :src="selectedBusiness.imageUrl"
                                        width="100%"
                                        height="50%"
                                        :alt="selectedBusiness.name"
                                        :title="selectedBusiness.name"
                                    />
                                    <q-img
                                        v-else
                                        src="~/assets/images/business-default-icon.png"
                                        width="45px"
                                        height="38px"
                                        :alt="selectedBusiness.name"
                                        :title="selectedBusiness.name"
                                    />
                                </q-item>
                            </div>
                            <div class="row justify-center text-center" v-else>
                                <div class="col-6">
                                    <div class="checked-in float-right q-pa-lg">
                                        <p class="items-center font-24 q-mt-sm">
                                            {{ $t('attendance.checkedIn') }}
                                        </p>
                                    </div>
                                </div>
                                <div class="col-6 q-pa-md">
                                    <div
                                        class="
                                            timer-container-checked
                                            float-left
                                            q-pt-md
                                        "
                                    >
                                        <div class="timer items-center">
                                            <p class="helvetica-neue-medium">
                                                {{
                                                    moment
                                                        .utc(state.startTime)
                                                        .local()
                                                        .format('H:mm:ss')
                                                }}
                                            </p>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="row q-mt-xl justify-center">
                                <div
                                    class="
                                        timer-container
                                        items-center
                                        text-center
                                    "
                                >
                                    <div class="timer q-pt-xl">
                                        <p class="helvetica-neue-medium">
                                            {{
                                                currentTime.toLocaleTimeString()
                                            }}
                                        </p>
                                    </div>
                                </div>
                            </div>
                            <div class="row q-mt-xl justify-center">
                                <div class="items-center text-center q-pt-xl">
                                    <q-btn
                                        color="primary"
                                        class="font-16 border-radius-30 q-px-xl"
                                        @click="checkinBtnPressed"
                                        v-if="!state.attendanceMode"
                                    >
                                        {{ $t('button.checkIn') }}
                                    </q-btn>

                                    <q-btn
                                        color="primary"
                                        class="font-16 border-radius-30 q-px-xl"
                                        @click="checkoutBtnPressed"
                                        v-else
                                    >
                                        {{ $t('button.checkOut') }}
                                    </q-btn>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </q-page>
    </div>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
import { useStore } from 'src/store';
import { mapGetters } from 'vuex';
import {
    defineComponent,
    reactive,
    ref,
    computed,
    watch,
    onMounted,
    onBeforeUnmount
} from 'vue';
import Notifications from 'src/components/commons/Notifications.vue';
import AutoAssign from 'src/components/commons/AutoAssign.vue';
import moment from 'moment';
import { useWindowSize } from 'vue-window-size';


export default defineComponent({
    components: { Notifications, AutoAssign },
    name: 'Attendance',
    computed: {
        ...mapGetters({
            selectedBusiness: 'business/getBusiness',
            selectedAgentId: 'attendance/getSelectedAgent',
            getStartTime: 'attendance/getStartTime'
        })
    },
    setup() {
        const { width, height } = useWindowSize();

        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        const selectedAttendanceId = computed(() => {
            return store.state.attendance.selectedAttendanceId;
        });

        // store
        const store = useStore();

        // data
        const count = ref(0);
        const currentTime = ref(new Date());
        let state = reactive({
            attendanceMode: ref(false),
            startTime: ''
        });

        // watch
        watch(selectedBusinessId, () => {
            updateStates();
        });

        watch(selectedAttendanceId, () => {
            updateStates();
        });

        // methods
        const checkinBtnPressed = async () => {
            const result: any = await store.dispatch('attendance/checkIn');

            if (result.status != 200) {
                await store.dispatch('attendance/view');
            }
        };

        const checkoutBtnPressed = async () => {
            const businessId = store.state.business.businessID;
            await store.dispatch('attendance/checkOut', businessId);
        };

        const updateCurrentTime = () => {
            currentTime.value = new Date();
        };

        const intervalHandle = setInterval(updateCurrentTime, 1000);

        const updateStates = () => {
            const findIndex = store.state.attendance.mode.findIndex(
                (element: any) => element.businessId == selectedBusinessId.value
            );
            if (findIndex != -1) {
                state.attendanceMode = true;
            } else {
                state.attendanceMode = false;
            }

            const findStartTime = store.state.attendance.attendance.findIndex(
                (element: any) => element.businessId == selectedBusinessId.value
            );

            if (findStartTime != -1) {
                state.startTime =
                    store.state.attendance.attendance[
                        findStartTime
                    ].startDateTime;
            }
        };

        onMounted(updateStates);

        onBeforeUnmount(() => {
            clearInterval(intervalHandle);
        });

        return {
            state,
            moment,
            count,
            currentTime,
            intervalHandle,
            checkinBtnPressed,
            checkoutBtnPressed,
            windowWidth: width,
        };
    }
});
</script>
